<?php
defined('_JEXEC') or die('Restricted acccess');

jimport('joomla.application.component.controlleradmin');
jimport('joomla.filesystem.file');

class Form2ContentMigrationControllerMigration extends JControllerLegacy
{
	private $db;
	private $oldPrefix;
	private $eraseData;
	private $catConvert;
	private $lstNewViewLevels;
	private $lstOldViewLevels;		
	
	private function __getRedirect()
	{
		return 'index.php?option=com_form2contentmigration&old_table_prefix='.$this->oldPrefix.'&erase_data='.$this->eraseData;
	}
	
	public function migrate()
	{
		$this->db 			= JFactory::getDbo();
		$this->oldPrefix 	= JRequest::getString('old_table_prefix');
		$this->eraseData 	= JRequest::getString('erase_data');
		$app				= JFactory::getApplication();
		
		if(!JFile::exists(JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_form2content'.DIRECTORY_SEPARATOR.'tables'.DIRECTORY_SEPARATOR.'project.php'))
		{
			$app->enqueueMessage(JText::_('COM_FORM2CONTENT_MIGRATION_F2C_NOT_INSTALLED'), 'error');
			$this->setRedirect($this->__getRedirect());
			return false;
		}

		require_once(JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_form2content'.DIRECTORY_SEPARATOR.'tables'.DIRECTORY_SEPARATOR.'project.php');
		require_once(JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_form2content'.DIRECTORY_SEPARATOR.'tables'.DIRECTORY_SEPARATOR.'projectfield.php');
		require_once(JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_form2content'.DIRECTORY_SEPARATOR.'tables'.DIRECTORY_SEPARATOR.'form.php');
		require_once(JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_form2content'.DIRECTORY_SEPARATOR.'tables'.DIRECTORY_SEPARATOR.'fieldcontent.php');
		require_once(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_form2content'.DIRECTORY_SEPARATOR.'shared.form2content.php');
		
		// test if J1.5 tables are present
		$this->db->setQuery('SELECT * FROM ' .$this->oldPrefix . 'f2c_project');
		
		if(!$this->db->query())
		{
			$app->enqueueMessage(JText::_('COM_FORM2CONTENT_MIGRATION_OLD_TABLES_NOT_FOUND'), 'error');
			$this->setRedirect($this->__getRedirect());
			return false;
		}
		
		// test if F2C for Joomla 1.7 is installed
		$this->db->setQuery('SELECT * FROM #__f2c_project');
		
		if(!$this->db->query())
		{
			$app->enqueueMessage(JText::_('COM_FORM2CONTENT_MIGRATION_NEW_TABLES_NOT_FOUND'), 'error');
			$this->setRedirect($this->__getRedirect());
			return false;
		}
		
		// check if we need to erase the current data
		if(JRequest::getString('erase_data'))
		{
			$this->db->setQuery('delete from #__f2c_fieldcontent');
			$this->db->query();
			$this->db->setQuery('delete from #__f2c_form');
			$this->db->query();
			$this->db->setQuery('delete from #__f2c_project');
			$this->db->query();
			$this->db->setQuery('delete from #__f2c_projectfields');
			$this->db->query();
			$this->db->setQuery('delete from #__f2c_translation');
			$this->db->query();
		}
		
		// create a lookup for the access view levels
		$this->db->setQuery('SELECT id, lower(title) as title FROM #__viewlevels;');
		$this->lstNewViewLevels = $this->db->loadObjectList('title');
		
		$this->db->setQuery('SELECT id, lower(name) AS title FROM ' .$this->oldPrefix . 'groups;');
		$this->lstOldViewLevels = $this->db->loadObjectList('id');
		
		// fill the category conversion array
		$this->db->setQuery('SELECT c15.id AS oldId, c17.id AS newId FROM ' .$this->oldPrefix . 'categories c15 LEFT JOIN #__categories c17 on c15.alias = c17.alias WHERE CONVERT(c15.section, SIGNED INTEGER) <> 0');
		$this->catConvert = $this->db->loadObjectList('oldId');
		// get the special 'uncategorized' category
		$this->db->setQuery('SELECT 0 as oldId, id as newId FROM #__categories where extension = ' . $this->db->quote('com_content') . ' and alias = ' . $this->db->quote('uncategorised'));
		$this->catConvert[0] = $this->db->loadObject();
		
		$this->upgradeProjects();
		$this->upgradeForms();
		$this->UpgradeFormData();
		
			$app->enqueueMessage(JText::_('COM_FORM2CONTENT_MIGRATION_FINISHED'));
			$this->setRedirect($this->__getRedirect());
			return true;		
	}
	
	public function upgradeProjects()
	{
		$this->db->setQuery('SELECT * FROM ' .$this->oldPrefix . 'f2c_project WHERE id NOT IN (SELECT id FROM #__f2c_project)');
		$lstOldContentTypes = $this->db->loadObjectList();
		
		if(count($lstOldContentTypes))
		{
			foreach($lstOldContentTypes as $oldContentType)
			{
				if($oldContentType->settings)
				{
					$oldContentType->settings = unserialize($oldContentType->settings);
				}
				else
				{
					$oldContentType->settings = new F2C_ContentTypeSettings();
				}
				
				$oldContentType->metadata 	= new JRegistry($oldContentType->metadata);
				$oldContentType->attribs 	= new JRegistry($oldContentType->attribs);
				
				$newContentType 	= new Form2ContentTableProject($this->db);
				$data				= array();				
				$data['id'] 		= null;
				$data['title'] 		= $oldContentType->title;
				$data['asset_id'] 	= null; // force insert
				$data['published']	= $oldContentType->published;
				$data['created']	= $oldContentType->created;
				$data['modified']	= $oldContentType->modified;
				$data['created_by']	= $oldContentType->created_by;
				$data['version']	= $oldContentType->version;
				$data['metakey']	= $oldContentType->settings->metakey_default;
				$data['metadesc']	= $oldContentType->settings->metadesc_default;
				$data['metadata']	= array();
				$data['settings'] 	= array();
				$data['attribs'] 	= array();
				
				$data['settings']['article_caption'] = $oldContentType->settings->article_caption;				
				$data['settings']['title_front_end'] = $oldContentType->settings->title_front_end;
				$data['settings']['title_caption'] = $oldContentType->settings->title_caption;
				$data['settings']['title_default'] = $oldContentType->settings->title_default;
				$data['settings']['title_alias_front_end'] = $oldContentType->settings->title_alias_front_end;
				$data['settings']['title_alias_caption'] = $oldContentType->settings->title_alias_caption;
				$data['settings']['metadesc_front_end'] = $oldContentType->settings->metadesc_front_end;
				$data['settings']['metadesc_caption'] = $oldContentType->settings->metadesc_caption;
				$data['settings']['metakey_front_end'] = $oldContentType->settings->metakey_front_end;
				$data['settings']['metakey_caption'] = $oldContentType->settings->metakey_caption;
				$data['settings']['frontend_catsel'] = $oldContentType->frontend_catsel;
				$data['settings']['category_caption'] = $oldContentType->settings->section_category_caption;
				$data['settings']['catid'] = array_key_exists($oldContentType->catid, $this->catConvert) ? $this->catConvert[$oldContentType->catid]->newId : $oldContentType->catid;
				$data['settings']['cat_behaviour'] = 0;				
				$data['settings']['author_front_end'] = $oldContentType->settings->created_by_front_end;
				$data['settings']['author_caption'] = $oldContentType->settings->created_by_caption;
				$data['settings']['author_alias_front_end'] = $oldContentType->settings->created_by_alias_front_end;
				$data['settings']['author_alias_caption'] = $oldContentType->settings->created_by_alias_caption;
				$data['settings']['access_level_front_end'] = $oldContentType->settings->access_front_end;
				$data['settings']['access_level_caption'] = $oldContentType->settings->access_caption;
				$data['settings']['access_default'] = $this->lstNewViewLevels[$this->lstOldViewLevels[$oldContentType->settings->access_default]->title]->id;				
				$data['settings']['frontend_templsel'] = $oldContentType->frontend_templsel;				
				$data['settings']['intro_template'] = $oldContentType->intro_template;				
				$data['settings']['main_template'] = $oldContentType->main_template;				
				$data['settings']['date_created_front_end'] = $oldContentType->settings->date_created_front_end;				
				$data['settings']['frontend_pubsel'] = $oldContentType->frontend_pubsel;				
				$data['settings']['state_front_end'] = $oldContentType->settings->state_front_end;				
				$data['settings']['state_caption'] = $oldContentType->settings->state_caption;				
				$data['settings']['state_default'] = $oldContentType->settings->state_default;				
				$data['settings']['featured_front_end'] = $oldContentType->settings->frontpage_front_end;				
				$data['settings']['featured_caption'] = $oldContentType->settings->frontpage_caption;				
				$data['settings']['featured_default'] = $oldContentType->settings->frontpage_default;		
				$data['settings']['language_front_end'] = 1;
				$data['settings']['language_caption'] = '';
				$data['settings']['language_default'] = '';		
				$data['settings']['max_forms'] = $oldContentType->settings->max_forms;
				$data['settings']['captcha_front_end'] = $oldContentType->settings->captcha_front_end;
				$data['settings']['required_field_text'] = $oldContentType->settings->required_field_text;

				$data['metadata']['robots'] = $oldContentType->metadata->get('robots');
				$data['metadata']['author'] = $oldContentType->metadata->get('author');
				$data['metadata']['xreference'] = '';
				$data['metadata']['rights'] = '';

				$data['attribs']['show_title'] = $oldContentType->attribs->get('show_title');
				$data['attribs']['link_titles'] = $oldContentType->attribs->get('link_titles');
				$data['attribs']['show_intro'] = $oldContentType->attribs->get('show_intro');
				$data['attribs']['show_category'] = $oldContentType->attribs->get('show_category');
				$data['attribs']['link_category'] = $oldContentType->attribs->get('link_category');
				$data['attribs']['show_parent_category'] = '';
				$data['attribs']['link_parent_category'] = '';
				$data['attribs']['show_author'] = $oldContentType->attribs->get('show_author');
				$data['attribs']['link_author'] = '';
				$data['attribs']['show_create_date'] = $oldContentType->attribs->get('show_create_date');
				$data['attribs']['show_modify_date'] = $oldContentType->attribs->get('show_modify_date');
				$data['attribs']['show_publish_date'] = '';
				$data['attribs']['show_item_navigation'] = '';
				$data['attribs']['show_icons'] = '';
				$data['attribs']['show_print_icon'] = $oldContentType->attribs->get('show_print_icon');
				$data['attribs']['show_email_icon'] = $oldContentType->attribs->get('show_email_icon');
				$data['attribs']['show_vote'] = $oldContentType->attribs->get('show_vote');
				$data['attribs']['show_hits'] = '';
				$data['attribs']['show_noauth'] = '';
				$data['attribs']['alternative_readmore'] = $oldContentType->attribs->get('readmore');
				$data['attribs']['article_layout'] = '';
			
				$newContentType->bind($data);
				$newContentType->store();
				
				// Restore the original Id
				$this->db->setQuery('UPDATE #__f2c_project SET id = ' . (int)$oldContentType->id . ' WHERE id = ' . (int)$newContentType->id);
				$this->db->query();
			}
		}
		
		// Upgrade the Content Type Fields
		$this->db->setQuery('SELECT * FROM ' .$this->oldPrefix . 'f2c_projectfields WHERE id NOT IN (SELECT id FROM #__f2c_projectfields) ORDER BY projectid, ordering');
		$lstOldContentTypeFields = $this->db->loadObjectList();
		
		if(count($lstOldContentTypeFields))
		{
			foreach($lstOldContentTypeFields as $oldContentTypeField)
			{
				$newContentTypeField 	= new Form2ContentTableProjectField($this->db);
				$data					= array();
				$data['id']				= null; // force insert
				$data['projectid']		= $oldContentTypeField->projectid;
				$data['fieldname']		= $oldContentTypeField->fieldname;
				$data['title']			= $oldContentTypeField->title;
				$data['description']	= $oldContentTypeField->description;
				$data['fieldtypeid']	= $oldContentTypeField->fieldtypeid;
				$data['settings'] 		= array();
				$data['ordering']		= $oldContentTypeField->ordering;
				$data['frontvisible']	= $oldContentTypeField->frontvisible;
								
				switch($oldContentTypeField->fieldtypeid)
				{
					case F2C_FIELDTYPE_SINGLELINE:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_SingleLineTextSettings();
						$data['settings']['slt_size'] 					= $oldContentTypeField->settings->size;
						$data['settings']['slt_max_length'] 			= $oldContentTypeField->settings->maxLength;
						$data['settings']['slt_attributes'] 			= $oldContentTypeField->settings->attributes;
						break;
						
					case F2C_FIELDTYPE_MULTILINETEXT:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_MultiLineTextSettings();
						$data['settings']['mlt_num_rows'] 				= $oldContentTypeField->settings->numRows;
						$data['settings']['mlt_num_cols'] 				= $oldContentTypeField->settings->numCols;
						$data['settings']['mlt_attributes'] 			= $oldContentTypeField->settings->attributes;
						$data['settings']['mlt_max_num_chars'] 			= $oldContentTypeField->settings->maxNumChars;
						break;
						
					case F2C_FIELDTYPE_MULTILINEEDITOR:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_MultiLineEditorSettings();
						$data['settings']['mle_num_rows'] 				= $oldContentTypeField->settings->numRows;
						$data['settings']['mle_num_cols'] 				= $oldContentTypeField->settings->numCols;
						$data['settings']['mle_width'] 					= $oldContentTypeField->settings->width;
						$data['settings']['mle_height'] 				= $oldContentTypeField->settings->height;
						break;
						
					case F2C_FIELDTYPE_CHECKBOX:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_CheckBoxSettings();
						$data['settings']['chk_attributes'] 			= $oldContentTypeField->settings->attributes;
						break;
						
					case F2C_FIELDTYPE_SINGLESELECTLIST:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_SingleSelectSettings();
						$data['settings']['ssl_display_mode'] 			= $oldContentTypeField->settings->displayMode;
						$data['settings']['ssl_show_empty_choice_text'] = $oldContentTypeField->settings->showEmptyText;
						$data['settings']['ssl_empty_choice_text'] 		= $oldContentTypeField->settings->emptyText;
						$data['settings']['ssl_options'] 				= $oldContentTypeField->settings->listOptions;
						$data['settings']['ssl_attributes'] 			= $oldContentTypeField->settings->attributes;
						break;
						
					case F2C_FIELDTYPE_IMAGE:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_ImageSettings();
						$data['settings']['img_max_width'] 				= $oldContentTypeField->settings->width;
						$data['settings']['img_max_height'] 			= $oldContentTypeField->settings->height;
						$data['settings']['img_thumb_width'] 			= $oldContentTypeField->settings->thumbnailWidth;
						$data['settings']['img_thumb_height'] 			= $oldContentTypeField->settings->thumbnailHeight;
						$data['settings']['img_output_mode'] 			= $oldContentTypeField->settings->imageOutputMode;
						$data['settings']['img_attributes_image'] 		= $oldContentTypeField->settings->uploadAttributes;
						$data['settings']['img_attributes_delete'] 		= $oldContentTypeField->settings->deleteAttributes;
						$data['settings']['img_attributes_alt_text'] 	= $oldContentTypeField->settings->altValueAttributes;
						$data['settings']['img_attributes_title'] 		= $oldContentTypeField->settings->titleAttributes;
						$data['settings']['img_show_alt_tag'] 			= $oldContentTypeField->settings->showAltTag;
						$data['settings']['img_show_title_tag'] 		= $oldContentTypeField->settings->showTitleTag;
						break;
						
					case F2C_FIELDTYPE_IFRAME:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_IFrameSettings();
						$data['settings']['ifr_attributes_iframe'] 		= $oldContentTypeField->settings->iFrameAttributes;
						$data['settings']['ifr_attributes_width'] 		= $oldContentTypeField->settings->widthAttributes;
						$data['settings']['ifr_attributes_height'] 		= $oldContentTypeField->settings->heightAttributes;
						break;
						
					case F2C_FIELDTYPE_EMAIL:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_EmailSettings();
						$data['settings']['eml_attributes_email'] 		= $oldContentTypeField->settings->emailAttributes;
						$data['settings']['eml_attributes_display_as'] 	= $oldContentTypeField->settings->displayAsAttributes;
						$data['settings']['eml_show_display_as'] 		= $oldContentTypeField->settings->showDisplayAs;
						break;
						
					case F2C_FIELDTYPE_HYPERLINK:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_LinkSettings();
						$data['settings']['lnk_output_mode'] 			= $oldContentTypeField->settings->outputMode;
						$data['settings']['lnk_attributes_url'] 		= $oldContentTypeField->settings->linkAttributes;
						$data['settings']['lnk_attributes_display_as'] 	= $oldContentTypeField->settings->displayAsAttributes;
						$data['settings']['lnk_attributes_title'] 		= $oldContentTypeField->settings->titleAttributes;
						$data['settings']['lnk_attributes_target'] 		= $oldContentTypeField->settings->targetAttributes;
						$data['settings']['lnk_show_display_as'] 		= $oldContentTypeField->settings->showDisplayAs;
						$data['settings']['lnk_show_title'] 			= $oldContentTypeField->settings->showTitle;
						$data['settings']['lnk_show_target'] 			= $oldContentTypeField->settings->showTarget;
						$data['settings']['lnk_add_http_prefix'] 		= $oldContentTypeField->settings->addHttpPrefix;
						break;
						
					case F2C_FIELDTYPE_MULTISELECTLIST:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_MultiSelectSettings();
						$data['settings']['msl_options'] 				= $oldContentTypeField->settings->listOptions;
						$data['settings']['msl_attributes'] 			= $oldContentTypeField->settings->attributes;
						$data['settings']['msl_pre_list_tag'] 			= $oldContentTypeField->settings->preListTag;
						$data['settings']['msl_post_list_tag'] 			= $oldContentTypeField->settings->postListTag;
						$data['settings']['msl_pre_element_tag'] 		= $oldContentTypeField->settings->preElementTag;
						$data['settings']['msl_post_element_tag'] 		= $oldContentTypeField->settings->postElementTag;
						break;
						
					case F2C_FIELDTYPE_INFOTEXT:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_InfoTextSettings();
						$data['settings']['inf_text'] 					= $oldContentTypeField->settings->text;
						break;
						
					case F2C_FIELDTYPE_DATEPICKER:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_DatePickerSettings();
						$data['settings']['dat_attributes'] 			= $oldContentTypeField->settings->attributes;
						break;
						
					case F2C_FIELDTYPE_DISPLAYLIST:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_DisplayListSettings();
						$data['settings']['dsp_output_mode'] 			= $oldContentTypeField->settings->ordered;
						$data['settings']['dsp_attributes_table'] 		= $oldContentTypeField->settings->attributesTable;
						$data['settings']['dsp_attributes_tr'] 			= $oldContentTypeField->settings->attributesTr;
						$data['settings']['dsp_attributes_th'] 			= $oldContentTypeField->settings->attributesTh;
						$data['settings']['dsp_attributes_td'] 			= $oldContentTypeField->settings->attributesTd;
						$data['settings']['dsp_attributes_item_text'] 	= $oldContentTypeField->settings->attributesItemText;
						$data['settings']['dsp_attributes_add_button'] 	= $oldContentTypeField->settings->attributesAddButton;						
						break;
						
					case F2C_FIELDTYPE_FILE:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_FileSettings();
						$data['settings']['ful_output_mode'] 			= $oldContentTypeField->settings->outputMode;
						$data['settings']['ful_whitelist'] 				= $oldContentTypeField->settings->whiteList;
						$data['settings']['ful_blacklist'] 				= $oldContentTypeField->settings->blackList;
						$data['settings']['ful_attributes_upload'] 		= $oldContentTypeField->settings->uploadAttributes;
						$data['settings']['ful_attributes_delete'] 		= $oldContentTypeField->settings->deleteAttributes;
						$data['settings']['ful_max_file_size'] 			= $oldContentTypeField->settings->maxFileSize;
						break;
						
					case F2C_FIELDTYPE_DATABASE_LOOKUP:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_DatabaseLookupSettings();
						$data['settings']['dbl_display_mode'] 			= $oldContentTypeField->settings->displayMode;
						$data['settings']['dbl_show_empty_choice_text'] = $oldContentTypeField->settings->showEmptyText;
						$data['settings']['dbl_empty_choice_text'] 		= $oldContentTypeField->settings->emptyText;
						$data['settings']['dbl_query'] 					= $oldContentTypeField->settings->query;
						$data['settings']['dbl_attributes'] 			= $oldContentTypeField->settings->attributes;
						break;
						
					case F2C_FIELDTYPE_GEOCODER:
						$oldContentTypeField->settings 						= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_GeoCoderSettings();
						$data['settings']['gcd_show_map'] 					= $oldContentTypeField->settings->showMap;
						$data['settings']['gcd_map_width'] 					= $oldContentTypeField->settings->mapWidth;
						$data['settings']['gcd_map_height'] 				= $oldContentTypeField->settings->mapHeight;
						$data['settings']['gcd_map_lat'] 					= $oldContentTypeField->settings->mapLat;
						$data['settings']['gcd_map_lon'] 					= $oldContentTypeField->settings->mapLon;
						$data['settings']['gcd_map_zoom'] 					= $oldContentTypeField->settings->mapZoom;
						$data['settings']['gcd_map_type'] 					= $oldContentTypeField->settings->mapType;
						$data['settings']['gcd_attributes_address'] 		= $oldContentTypeField->settings->attributesAddress;
						$data['settings']['gcd_attributes_lookup_lat_lon']	= $oldContentTypeField->settings->attributesLookup;
						$data['settings']['gcd_attributes_clear_results'] 	= $oldContentTypeField->settings->attributesClear;
						break;
						
					case F2C_FIELDTYPE_DB_LOOKUP_MULTI:
						$oldContentTypeField->settings 					= $oldContentTypeField->settings ? unserialize($oldContentTypeField->settings) : new F2C_DatabaseLookupMultiSettings();
						$data['settings']['dlm_output_mode'] 			= $oldContentTypeField->settings->ordered;
						$data['settings']['dlm_attributes_table'] 		= $oldContentTypeField->settings->attributesTable;
						$data['settings']['dlm_attributes_tr'] 			= $oldContentTypeField->settings->attributesTr;
						$data['settings']['dlm_attributes_th'] 			= $oldContentTypeField->settings->attributesTh;
						$data['settings']['dlm_attributes_td'] 			= $oldContentTypeField->settings->attributesTd;
						$data['settings']['dlm_attributes_item_text'] 	= $oldContentTypeField->settings->attributesItemText;
						$data['settings']['dlm_attributes_add_button'] 	= $oldContentTypeField->settings->attributesAddButton;
						$data['settings']['dlm_attributes_select'] 		= $oldContentTypeField->settings->attributesSelect;
						$data['settings']['dlm_show_empty_choice_text'] = $oldContentTypeField->settings->showEmptyText;
						$data['settings']['dlm_empty_choice_text'] 		= $oldContentTypeField->settings->emptyText;
						$data['settings']['dlm_query'] 					= $oldContentTypeField->settings->query;
						break;
				}
				
				$data['settings']['requiredfield'] 			= $oldContentTypeField->settings->required;
				$data['settings']['error_message_required'] = $oldContentTypeField->settings->errorMessageRequired;
				
				$newContentTypeField->bind($data);
				$newContentTypeField->store();
				
				// Restore the original Id
				$this->db->setQuery('UPDATE #__f2c_projectfields SET id = ' . (int)$oldContentTypeField->id . ' WHERE id = ' . (int)$newContentTypeField->id);
				$this->db->query();				
			}			
		}

		// copy the translations
		$this->db->setQuery('INSERT INTO #__f2c_translation SELECT * FROM ' .$this->oldPrefix . 'f2c_translation WHERE id NOT IN (SELECT id FROM #__f2c_translation)');
		$this->db->query();
	}		

	public function upgradeForms()
	{
		$this->db->setQuery('SELECT * FROM ' .$this->oldPrefix . 'f2c_form WHERE id NOT IN (SELECT id FROM #__f2c_form)');
		$lstOldForms = $this->db->loadObjectList();
		
		if(count($lstOldForms))
		{
			foreach($lstOldForms as $oldForm)
			{
				$oldForm->metadata 							= new JRegistry($oldForm->metadata);
				$oldForm->attribs 							= new JRegistry($oldForm->attribs);
				$newForm 									= new Form2ContentTableForm($this->db);
				$data										= array();
				$data['id'] 								= null; // force insert
				$data['asset_id']							= null; // force insert
				$data['projectid'] 							= $oldForm->projectid;
				$data['title'] 								= $oldForm->title;
				$data['alias'] 								= $oldForm->title_alias;
				$data['created_by'] 						= $oldForm->created_by;
				$data['created_by_alias'] 					= $oldForm->created_by_alias;
				$data['created'] 							= $oldForm->created;
				$data['modified'] 							= $oldForm->modified;
				$data['metakey'] 							= $oldForm->metakey;
				$data['metadesc'] 							= $oldForm->metadesc;
				$data['sectionid']							= 0;
				$data['catid'] 								= array_key_exists($oldForm->catid, $this->catConvert) ? $this->catConvert[$oldForm->catid]->newId : $oldForm->catid;
				$data['intro_template'] 					= $oldForm->intro_template;
				$data['main_template'] 						= $oldForm->main_template;
				$data['reference_id'] 						= $oldForm->reference_id;
				$data['ordering'] 							= $oldForm->ordering;
				$data['publish_up'] 						= $oldForm->publish_up;
				$data['publish_down'] 						= $oldForm->publish_down;
				$data['state'] 								= $oldForm->state;
				$data['featured'] 							= $oldForm->frontpage;				
				$data['access']								= $this->lstNewViewLevels[$this->lstOldViewLevels[$oldForm->access]->title]->id;			
				$data['metadata']							= array();				
				$data['metadata']['robots'] 				= $oldForm->metadata->get('robots');
				$data['metadata']['author'] 				= $oldForm->metadata->get('author');
				$data['metadata']['xreference'] 			= '';
				$data['metadata']['rights'] 				= '';
				$data['attribs']							= array();
				$data['attribs']['show_title'] 				= $oldForm->attribs->get('show_title');
				$data['attribs']['link_titles'] 			= $oldForm->attribs->get('link_titles');
				$data['attribs']['show_intro'] 				= $oldForm->attribs->get('show_intro');
				$data['attribs']['show_category'] 			= $oldForm->attribs->get('show_category');
				$data['attribs']['link_category'] 			= $oldForm->attribs->get('link_category');
				$data['attribs']['show_parent_category'] 	= '';
				$data['attribs']['link_parent_category'] 	= '';
				$data['attribs']['show_author'] 			= $oldForm->attribs->get('show_author');
				$data['attribs']['link_author'] 			= '';
				$data['attribs']['show_create_date'] 		= $oldForm->attribs->get('show_create_date');
				$data['attribs']['show_modify_date'] 		= $oldForm->attribs->get('show_modify_date');
				$data['attribs']['show_publish_date'] 		= '';
				$data['attribs']['show_item_navigation'] 	= '';
				$data['attribs']['show_icons'] 				= '';
				$data['attribs']['show_print_icon'] 		= $oldForm->attribs->get('show_print_icon');
				$data['attribs']['show_email_icon'] 		= $oldForm->attribs->get('show_email_icon');
				$data['attribs']['show_vote'] 				= $oldForm->attribs->get('show_vote');
				$data['attribs']['show_hits'] 				= '';
				$data['attribs']['show_noauth'] 			= '';
				$data['attribs']['alternative_readmore']	= $oldForm->attribs->get('readmore');
				$data['attribs']['article_layout'] 			= '';
				$data['language']							= '*';
				
				$newForm->bind($data);
				$newForm->store();
				
				// Restore the original Id
				$this->db->setQuery('UPDATE #__f2c_form SET id = ' . (int)$oldForm->id . ' WHERE id = ' . (int)$newForm->id);
				$this->db->query();
			}
		}
	}
	
	public function UpgradeFormData()
	{ 
		// Transfer the fields that don't need a conversion
		$this->db->setQuery('INSERT INTO #__f2c_fieldcontent (id, formid, fieldid, attribute, content) SELECT fc.id, fc.formid, fc.fieldid, \'VALUE\', fc.content from '.$this->oldPrefix.'f2c_fieldcontent fc INNER JOIN '.$this->oldPrefix.'f2c_projectfields pf ON fc.fieldid = pf.id WHERE pf.fieldtypeid IN (1,2,3,4,5,11,12,14,15,16,17) AND fc.id NOT IN (SELECT id FROM #__f2c_fieldcontent)');
		$this->db->query();

		$this->db->setQuery('SELECT fc.*, pf.fieldtypeid FROM '.$this->oldPrefix.'f2c_fieldcontent fc INNER JOIN '.$this->oldPrefix.'f2c_projectfields pf ON fc.fieldid = pf.id WHERE pf.fieldtypeid IN (6,7,8,9,13) AND fc.id NOT IN (SELECT id FROM #__f2c_fieldcontent)');
		
		$oldFieldDataList = $this->db->loadObjectList();
		
		if(count($oldFieldDataList))
		{
			foreach($oldFieldDataList as $oldFieldData)
			{
				$fieldContent 	= new TableFieldContent($this->db);
				$content 		= new JRegistry();
				
				$oldFieldData->content = unserialize($oldFieldData->content);
				
				switch($oldFieldData->fieldtypeid)
				{
					case F2C_FIELDTYPE_IMAGE:
						$content->set('filename', $oldFieldData->content->filename);
						$content->set('width', $oldFieldData->content->width);
						$content->set('height', $oldFieldData->content->height);
						$content->set('widthThumbnail', $oldFieldData->content->widthThumbnail);
						$content->set('heightThumbnail', $oldFieldData->content->heightThumbnail);
						$content->set('alt', $oldFieldData->content->alt);
						$content->set('title', $oldFieldData->content->title);
						break;
						
					case F2C_FIELDTYPE_IFRAME:
						$content->set('url', $oldFieldData->content->url);
						$content->set('width', $oldFieldData->content->width);
						$content->set('height', $oldFieldData->content->height);
						break;
						
					case F2C_FIELDTYPE_EMAIL:
						$content->set('email', $oldFieldData->content->email);
						$content->set('display', $oldFieldData->content->display);
						break;
						
					case F2C_FIELDTYPE_HYPERLINK:
						$content->set('url', $oldFieldData->content->url);
						$content->set('display', $oldFieldData->content->display);
						$content->set('title', $oldFieldData->content->title);
						$content->set('target', $oldFieldData->content->target);
						break;
						
					case F2C_FIELDTYPE_DISPLAYLIST:
						$content->loadArray($oldFieldData->content);
						break;
				}
				
				$fieldContent->id 			= null; // force insert
				$fieldContent->formid 		= $oldFieldData->formid;
				$fieldContent->fieldid 		= $oldFieldData->fieldid;
				$fieldContent->attribute 	= $oldFieldData->attribute;
				$fieldContent->content 		= $content->toString();				
				$fieldContent->store();
				
				// Restore the original Id
				$this->db->setQuery('UPDATE #__f2c_fieldcontent SET id = ' . (int)$oldFieldData->id . ' WHERE id = ' . (int)$fieldContent->id);
				$this->db->query();				
			}
		}
		
		// convert the multiselect fields
		$this->db->setQuery('SELECT * FROM '.$this->oldPrefix.'f2c_fieldcontent fc INNER JOIN '.$this->oldPrefix.'f2c_projectfields pf ON fc.fieldid = pf.id WHERE pf.fieldtypeid IN (10)');
		
		$oldFieldDataList = $this->db->loadObjectList();
		
		if(count($oldFieldDataList))
		{
			foreach($oldFieldDataList as $oldFieldData)
			{
				$fieldContent 	= new TableFieldContent($this->db);
				
				$oldFieldData->content = unserialize($oldFieldData->content);

				if(count($oldFieldData->content))
				{
					foreach($oldFieldData->content as $value)
					{
						$fieldContent->id 			= null;
						$fieldContent->formid 		= $oldFieldData->formid;
						$fieldContent->fieldid 		= $oldFieldData->fieldid;
						$fieldContent->attribute 	= $oldFieldData->attribute;
						$fieldContent->content 		= $value;
						$fieldContent->store();
					}
				}
				
			}
		}
	}
}

class F2C_ContentTypeSettings
{
	var $article_caption			= '';
	var $title_front_end	 		= 1;
	var $title_caption 				= '';
	var $title_default				= '';
	var $title_alias_front_end 		= 1;
	var $title_alias_caption		= '';
	var $metakey_front_end 			= 1;
	var $metakey_caption	 		= '';
	var $metakey_default	 		= '';
	var $metadesc_front_end 		= 1;
	var $metadesc_caption 			= '';
	var $metadesc_default 			= '';
//  var $section_category_front_end	= 1; through db field
	var $section_category_caption 	= '';
	var $max_forms					= 0;
	var $state_front_end			= 0;
	var $state_default				= 0;
	var $state_caption				= '';
	var $frontpage_front_end		= 0;
	var $frontpage_default			= 0;
	var $frontpage_caption			= '';
	var $created_by_front_end		= 0;
	var $created_by_caption			= '';
	var $created_by_alias_front_end	= 0;
	var $created_by_alias_caption	= '';
	var $access_front_end			= 0;
	var $access_caption				= '';
	var $access_default				= 1;
	var $date_created_front_end		= 0;
	var $captcha_front_end			= 0;
	var $required_field_text		= '';
	var $create_joomla_article		= 1;
	var $id_front_end				= 1;
}

class F2C_SingleLineTextSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $size;
	var $maxLength;
	var $attributes;
}

class F2C_MultiLineTextSettings
{
	var $maxNumChars = 0;
	var $required = 0;
	var $errorMessageRequired = '';
	var $numRows = 0;
	var $numCols = 0;
	var $attributes = '';
}

class F2C_MultiLineEditorSettings
{
	var $required = 0;
	var $errorMessageRequired = '';	
	var $numRows = 0;
	var $numCols = 0;
	var $width = 0;
	var $height = 0;
}

class F2C_CheckBoxSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';	
}

class F2C_SingleSelectSettings
{
	var $listOptions;
	var $displayMode = 0;
	var $showEmptyText = false;
	var $emptyText = '';
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';	
}

class F2C_ImageSettings
{
	var $width;
	var $height;	
	var $imageOutputMode;
	var $thumbnailWidth;
	var $thumbnailHeight;
	var $required = 0;
	var $errorMessageRequired = '';
	var $uploadAttributes = '';
	var $deleteAttributes = '';
	var $altValueAttributes = '';
	var $titleAttributes = '';
	var $showAltTag = true;
	var $showTitleTag = true;
}

class F2C_IFrameSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $iFrameAttributes;
	var $widthAttributes;
	var $heightAttributes;
}

class F2C_EmailSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $emailAttributes = '';
	var $displayAsAttributes = '';
	var $showDisplayAs = 1;
}

class F2C_MultiSelectSettings
{
	var $listOptions;
	var $required = 0;
	var $errorMessageRequired = '';	
	var $preListTag = '';
	var $postListTag = '';
	var $preElementTag = '';
	var $postElementTag = ',';
	var $attributes = '';
}

class F2C_LinkSettings
{
	var $outputMode;
	var $required = 0;
	var $errorMessageRequired = '';
	var $linkAttributes = '';
	var $displayAsAttributes = '';
	var $titleAttributes = '';
	var $targetAttributes = '';
	var $showDisplayAs = 1;
	var $showTitle = 1;
	var $showTarget = 1;
	var $addHttpPrefix = 0;
}

class F2C_InfoTextSettings
{
	var $text;
	var $required = 0;
	var $errorMessageRequired = '';	
}

class F2C_DatePickerSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';
}

class F2C_DisplayListSettings
{
	var $ordered = 1;
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributesTable = '';
	var $attributesTr = '';
	var $attributesTd = '';
	var $attributesTh = '';
	var $attributesItemText = '';
	var $attributesAddButton = '';	
}

class F2C_FileSettings
{
	var $whiteList = array();
	var $blackList = array();
	var $outputMode = 0;
	var $required = 0;
	var $errorMessageRequired = '';	
	var $uploadAttributes = '';
	var $deleteAttributes = '';
	var $maxFileSize = -1;
}

class F2C_DatabaseLookupSettings
{
	var $query = '';
	var $showEmptyText = false;
	var $emptyText = '';
	var $displayMode = 0;
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';	
}

class F2C_GeoCoderSettings
{
	var $showMap = true;
	var $mapWidth = '';
	var $mapHeight = '';
	var $mapLat = '';
	var $mapLon = '';
	var $mapZoom = 3;
	var $mapType = 'ROADMAP';
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributesAddress = '';
	var $attributesLookup = '';
	var $attributesClear = '';
}

class F2C_DatabaseLookupMultiSettings
{
	var $ordered = 1;
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributesTable = '';
	var $attributesTr = '';
	var $attributesTd = '';
	var $attributesTh = '';
	var $attributesItemText = '';
	var $attributesAddButton = '';		
	var $query = '';
	var $showEmptyText = false;
	var $emptyText = '';
	var $attributesSelect = '';		
}

class F2C_IFrame
{
	var $url;
	var $width;
	var $height;
}

class F2C_Email
{
	var $email;
	var $display;
}

class F2C_Link
{
	var $url;
	var $display;
	var $title;
	var $target;
}
?>